\section{Inverse Kinematics Problem}
Knowing the homogenous matrix ${}^0_6\mathcal{T}$ determine the joint variables
$\theta_i$. The given parameters are therefore the ones found in
\autoref{eqn:Td}.

The following sections include the development of the analytical solution for
the inverse kinematics problem. One can follow the flow of equations given as
they is considered self-explanatory where no comments are included. 

\subsection{Solve $\theta _1$ as a function of given parameters}

\begin{equation}
    {}^0_5\mathcal{T}={}^0_6\mathcal{T}_d . {}^5_6\mathcal{T}^{-1}
    \label{eqn:T for theta1}
\end{equation}

\begin{doublespace}
\noindent\begin{equation}{}^0_5\mathcal{T}=\left(
\begin{array}{cccc}
 c_6 r_{11}-r_{11} s_6 & r_{11} & -c_6 r_{11}-r_{11} s_6 & p_x-d_6 r_{11} \\
 c_6 r_{22}-r_{22} s_6 & r_{22} & -c_6 r_{22}-r_{22} s_6 & p_y-d_6 r_{22} \\
 c_6 r_{33}-r_{33} s_6 & r_{33} & -c_6 r_{33}-r_{33} s_6 & p_z-d_6 r_{33} \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}{}^0_6\mathcal{T}_d . {}^5_6\mathcal{T}^{-1}=\left(
\begin{array}{cccc}
c_5 s_1 s_4+c_1 \left(c_4 c_5 c_{\text{2+3}}-s_5 s_{\text{2+3}}\right) 
& ... & ... & c_1 \left(a_1+a_2 c_2+a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}\right) \\
c_5 \left(c_2 c_3 c_4 s_1-c_4 s_1 s_2 s_3-c_1 s_4\right)-s_1 s_5 s_{\text{2+3}} 
& ... & ... & s_1 \left(a_1+a_2 c_2+a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}\right) \\
-c_{\text{2+3}} s_5-c_4 c_5 s_{\text{2+3}} 
& ... & ... & -c_{\text{2+3}} d_4-a_2 s_2-a_3 s_{\text{2+3}} \\
0 & ... & ... & 1 \\
\end{array}
\right)\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\frac{{}^0_5\mathcal{T}_{24}}{{}^0_5\mathcal{T}_{14}} \to
    \text{tan}(\text{$\theta $1})=\frac{p_y-d_6 r_{22}}{p_x-d_6 r_{11}}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{l}
 \text{$\theta $1}\to \text{ArcTan}\left[\frac{p_y-d_6 r_{22}}{p_x-d_6 r_{11}}\right] \\
\end{array}\end{equation}
\end{doublespace}

\subsection{Solve $\theta _3$ as a function of given parameters and $\theta _1$}

\begin{equation}
    {}^2_5\mathcal{T}={}^0_2\mathcal{T}^{-1}.{}^0_6\mathcal{T}_d . {}^5_6\mathcal{T}^{-1}
    \label{eqn:T for theta2}
\end{equation}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}\left({}^2_5\mathcal{T}_{14}\right)^2 \to
    \left(a_2+a_3 c_3-d_4 s_3\right){}^2=\left(c_2 \left(a_1+c_1 \left(-p_x+d_6 r_{11}\right)-p_y s_1+d_6 r_{22} s_1\right)+\left(p_z-d_6
r_{33}\right) s_2\right){}^2 \\
    \left({}^2_5\mathcal{T}_{24}\right)^2 \to
    \left(c_3 d_4+a_3 s_3\right){}^2=\left(c_2 \left(p_z-d_6 r_{33}\right)-\left(a_1+c_1 \left(-p_x+d_6 r_{11}\right)-p_y s_1+d_6 r_{22}
s_1\right) s_2\right){}^2
\end{array}
\label{eqn:theta3 1}
\end{equation}
\end{doublespace}

As $\theta_1$ is considered a known parameter up to this point, we define some
constants in order to shorten the expressions. Using \autoref{eqn:relI} in
\autoref{eqn:theta3 1} and rearranging the bottom equation one can find
\autoref{eqn:theta3 2}.

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}
 p_z-d_6 r_{33}\to F \\
 a_1+c_1 \left(-p_x+d_6 r_{11}\right)-p_y s_1+d_6 r_{22} s_1\to G \\
\end{array}\label{eqn:relI}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}
-c_3^2 d_4^2-2 a_3 c_3 d_4 s_3-a_3^2 s_3^2=-F^2 c_2^2+2 F G c_2 s_2-G^2
s_2^2 \\
a_2^2+a_3^2+2 a_2 a_3 c_3+d_4^2=F^2+G^2+2 a_2 d_4 s_3
\end{array}
\label{eqn:theta3 2}
\end{equation}
\end{doublespace}

Bottom and top members of \autoref{eqn:theta3 2} can be combined together in
order to find \autoref{eqn:theta3 3}.

\begin{doublespace}
\noindent\begin{equation}a_3 c_3+\frac{-F^2-G^2+a_2^2+a_3^2+d_4^2}{2 a_2}=d_4
s_3
\label{eqn:theta3 3}
\end{equation}
\end{doublespace}

\autoref{eqn:theta3 3} can be simplified using the constant defined by
\autoref{eqn:relII} into \autoref{eqn:theta3 4}. Where $\theta_3$ can be solved
into \autoref{eqn:sol theta3}.

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}
 \frac{-F^2-G^2+a_2^2+a_3^2+d_4^2}{2 a_2}\to H \\
\end{array}\label{eqn:relII}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}H+a_3 c_3=d_4 s_3\label{eqn:theta3 4}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}
 \text{$\theta $3}\to \text{ArcTan}\left[\frac{H d_4-\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}}{\left(a_3^2+d_4^2\right) \sqrt{1-\frac{\left(-H
d_4+\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}\right){}^2}{\left(a_3^2+d_4^2\right){}^2}}}\right] \\
 \text{$\theta $3}\to \text{ArcTan}\left[\frac{H d_4+\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}}{\left(a_3^2+d_4^2\right) \sqrt{1-\frac{\left(H d_4+\sqrt{a_3^2
\left(-H^2+a_3^2+d_4^2\right)}\right){}^2}{\left(a_3^2+d_4^2\right){}^2}}}\right] \\
\end{array}\label{eqn:sol theta3}\end{equation}
\end{doublespace}

\subsection{Solve $\theta _2$ as a function of given parameters, $\theta _1$ and $\theta _3$}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{l}
 a_2+a_3 c_3-d_4 s_3\to J \\
\end{array}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}{}^2_5\mathcal{T}_{14} \to J=-G c_2-F s_2\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}
 \text{$\theta $2}\to \text{ArcTan}\left[\frac{-F J-\sqrt{G^2 \left(F^2+G^2-J^2\right)}}{\left(F^2+G^2\right) \sqrt{1-\frac{\left(F J+\sqrt{G^2 \left(F^2+G^2-J^2\right)}\right)^2}{\left(F^2+G^2\right)^2}}}\right]
\\
 \text{$\theta $2}\to \text{ArcTan}\left[\frac{-F J+\sqrt{G^2 \left(F^2+G^2-J^2\right)}}{\left(F^2+G^2\right) \sqrt{1-\frac{\left(-F J+\sqrt{G^2
\left(F^2+G^2-J^2\right)}\right)^2}{\left(F^2+G^2\right)^2}}}\right] \\
\end{array}\end{equation}
\end{doublespace}

\subsection{Solve $\theta _5$ as a function of given parameters, $\theta _1$, $\theta _2$ and $\theta _3$}

\begin{equation}
    {}^3_5\mathcal{T}={}^0_3\mathcal{T}^{-1}.{}^0_6\mathcal{T}_d . {}^5_6\mathcal{T}^{-1}
    \label{eqn:T for theta5}
\end{equation}

\begin{doublespace}
\noindent\begin{equation}{}^3_5\mathcal{T}_{22} \to c_5=-c_{\text{2+3}} r_{33}-c_1 r_{11} s_{\text{2+3}}-r_{22} s_1 s_{\text{2+3}}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{c}
 \text{$\theta $5}\to -\text{ArcTan}\left[\frac{\sqrt{1-\left(c_{\text{2+3}} r_{33}+\left(c_1 r_{11}+r_{22} s_1\right) s_{\text{2+3}}\right){}^2}}{c_{\text{2+3}}
r_{33}+\left(c_1 r_{11}+r_{22} s_1\right) s_{\text{2+3}}}\right] \\
\end{array}\end{equation}
\end{doublespace}

\subsection{Solve $\theta _4$ as a function of given parameters, $\theta _1$ and $\theta _5$}

\begin{doublespace}
\noindent\begin{equation}{}^3_5\mathcal{T}_{32} \to s_4 s_5=c_1 r_{22}-r_{11} s_1\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{l}
 \text{$\theta $4}\to \text{ArcTan}\left[\frac{\text{Csc}[\text{$\theta $5}] \left(c_1 r_{22}-r_{11} s_1\right)}{\sqrt{1-\text{Csc}[\text{$\theta
$5}]^2 \left(c_1 r_{22}-r_{11} s_1\right){}^2}}\right] \\
\end{array}\end{equation}
\end{doublespace}

\subsection{Solve $\theta _6$}

\begin{equation}
    {}^4_6\mathcal{T}={}^0_4\mathcal{T}^{-1} . {}^0_6\mathcal{T}_d
    \label{eqn:T for theta6}
\end{equation}

\begin{doublespace}
\noindent\begin{equation}{}^4_6\mathcal{T}_{22} \to c_6=r_{11} \left(c_4 s_1-c_1 c_{\text{2+3}} s_4\right)+r_{22} \left(-c_1 c_4-c_{\text{2+3}} s_1 s_4\right)+r_{33} s_4 s_{\text{2+3}}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{l}
 \text{$\theta $6}\to \text{ArcTan}\left[\frac{\sqrt{1-\left(-c_4 r_{11} s_1+c_1 \left(c_4 r_{22}+c_{\text{2+3}} r_{11} s_4\right)+s_4 \left(c_{\text{2+3}}
r_{22} s_1-r_{33} s_{\text{2+3}}\right)\right){}^2}}{c_4 r_{11} s_1-c_1 \left(c_4 r_{22}+c_{\text{2+3}} r_{11} s_4\right)+s_4 \left(-c_{\text{2+3}}
r_{22} s_1+r_{33} s_{\text{2+3}}\right)}\right] \\
\end{array}\end{equation}
\end{doublespace}

\subsection{Solution Summary}

A summary of the solutions obtained in the previous sections can be found in
\autoref{table:solutions}. Moreover, the abbreviations and constants defined
during the development of this solutions are summarized in \autoref{eqn:rels}
too.

\begin{doublespace}
\noindent\begin{equation}\begin{array}{ll}
 \text{$\theta $1}\to \text{ArcTan}\left[\frac{p_y-d_6 r_{22}}{p_x-d_6 r_{11}}\right] & \text{} \\
 \text{$\theta $2}\to \text{ArcTan}\left[\frac{-F J-\sqrt{G^2 \left(F^2+G^2-J^2\right)}}{\left(F^2+G^2\right) \sqrt{1-\frac{\left(F J+\sqrt{G^2 \left(F^2+G^2-J^2\right)}\right)^2}{\left(F^2+G^2\right)^2}}}\right]
& \text{$\theta $2}\to \text{ArcTan}\left[\frac{-F J+\sqrt{G^2 \left(F^2+G^2-J^2\right)}}{\left(F^2+G^2\right) \sqrt{1-\frac{\left(-F J+\sqrt{G^2
\left(F^2+G^2-J^2\right)}\right)^2}{\left(F^2+G^2\right)^2}}}\right] \\
 \text{$\theta $3}\to \text{ArcTan}\left[\frac{H d_4-\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}}{\left(a_3^2+d_4^2\right) \sqrt{1-\frac{\left(-H
d_4+\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}\right){}^2}{\left(a_3^2+d_4^2\right){}^2}}}\right] & \text{$\theta $3}\to \text{ArcTan}\left[\frac{H
d_4+\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}}{\left(a_3^2+d_4^2\right) \sqrt{1-\frac{\left(H d_4+\sqrt{a_3^2 \left(-H^2+a_3^2+d_4^2\right)}\right){}^2}{\left(a_3^2+d_4^2\right){}^2}}}\right]
\\
 \text{$\theta $4}\to \text{ArcTan}\left[\frac{\text{Csc}[\text{$\theta $5}] \left(c_1 r_{22}-r_{11} s_1\right)}{\sqrt{1-\text{Csc}[\text{$\theta
$5}]^2 \left(c_1 r_{22}-r_{11} s_1\right){}^2}}\right] & \text{} \\
 \text{$\theta $5}\to -\text{ArcTan}\left[\frac{\sqrt{1-\left(c_{\text{2+3}} r_{33}+\left(c_1 r_{11}+r_{22} s_1\right) s_{\text{2+3}}\right){}^2}}{c_{\text{2+3}}
r_{33}+\left(c_1 r_{11}+r_{22} s_1\right) s_{\text{2+3}}}\right] & \text{} \\
 \text{$\theta $6}\to \text{ArcTan}\left[\frac{\sqrt{1-\left(-c_4 r_{11} s_1+c_1 \left(c_4 r_{22}+c_{\text{2+3}} r_{11} s_4\right)+s_4 \left(c_{\text{2+3}}
r_{22} s_1-r_{33} s_{\text{2+3}}\right)\right){}^2}}{c_4 r_{11} s_1-c_1 \left(c_4 r_{22}+c_{\text{2+3}} r_{11} s_4\right)+s_4 \left(-c_{\text{2+3}}
r_{22} s_1+r_{33} s_{\text{2+3}}\right)}\right] & \text{} \\
\end{array}\label{table:solutions}\end{equation}
\end{doublespace}

\begin{doublespace}
\noindent\begin{equation}\begin{array}{l}
 F\to p_z-d_6 r_{33} \\
 G\to a_1+c_1 \left(-p_x+d_6 r_{11}\right)-p_y s_1+d_6 r_{22} s_1 \\
 H\to \frac{-F^2-G^2+a_2^2+a_3^2+d_4^2}{2 a_2} \\
 J\to a_2+a_3 c_3-d_4 s_3 \\
\end{array}\label{eqn:rels}\end{equation}
\end{doublespace}

This solution have been validated using some pre-defined joint variables with
the direct kinematics solution in order to compute an end-effector homogenous
matrix. Which then is used to calculate back a set of joint variables that are
solution of the inverse kinematics problem. The pre-defined joint variables can
be found therefore as one of the solutions output of the inverse kinematics.
Refer to the Mathematica notebook for more information.